/*
Copyright Caroline et Serge COUDÉ, (06/2012) 

serge.coude@gmail.com caroline.coude@laposte.net

Ce logiciel est un programme informatique faisant partie d'une suite de 
logiciels 'TbiSuite' à destination des enseignants et des élèves usagés des 
ordinateurs et Tableau Numérique Interactif / Tableau Blanc Interactif. 

Ce logiciel est régi par la licence CeCILL v2 soumise au droit français et
respectant les principes de diffusion des logiciels libres. Vous pouvez
utiliser, modifier et/ou redistribuer ce programme sous les conditions
de la licence CeCILL v2 telle que diffusée par le CEA, le CNRS et l'INRIA 
sur le site "http://www.cecill.info".

En contrepartie de l'accessibilité au code source et des droits de copie,
de modification et de redistribution accordés par cette licence, il n'est
offert aux utilisateurs qu'une garantie limitée.  Pour les mêmes raisons,
seule une responsabilité restreinte pèse sur l'auteur du programme,  le
titulaire des droits patrimoniaux et les concédants successifs.

A cet égard  l'attention de l'utilisateur est attirée sur les risques
associés au chargement,  à l'utilisation,  à la modification et/ou au
développement et à la reproduction du logiciel par l'utilisateur étant 
donné sa spécificité de logiciel libre, qui peut le rendre complexe à 
manipuler et qui le réserve donc à des développeurs et des professionnels
avertis possédant  des  connaissances  informatiques approfondies.  Les
utilisateurs sont donc invités à charger  et  tester  l'adéquation  du
logiciel à leurs besoins dans des conditions permettant d'assurer la
sécurité de leurs systèmes et ou de leurs données et, plus généralement, 
à l'utiliser et l'exploiter dans les mêmes conditions de sécurité. 

Le fait que vous puissiez accéder à cet en-tête signifie que vous avez 
pris connaissance de la licence CeCILL v2, et que vous en avez accepté les
termes.

*/
package net.sergecoude.TbiCetidem;

import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import java.io.*;
import net.sergecoude.TbiGeneral.*;

public class PanelConfigCetidem extends PanelConfig {

  private final static long serialVersionUID = 1L;

  private JComboBox _cbNbImages;
  private JComboBox _cbQuantiteIdentique;
  private JComboBox _cbVisibiliteModele;
  private JCheckBox _cbNomPrononce;
  private JCheckBox _cbRotation;
  private JTextField _tfCheminDesThemes;  
  private bouton _bChoisir;
	
  public PanelConfigCetidem(TbiCetidem app) {
    super(app);
		
    // nombres d'images proposées
    String[] nbImages = { "2", "3", "4", "5", "6" };
    _cbNbImages = new JComboBox(nbImages);
    _cbNbImages.setSelectedItem(Integer.toString(((TbiCetidem)_app).getNbImagesProposees()));
    _cbNbImages.setPreferredSize(new Dimension(80,30));
    _cbNbImages.setFont(_police);
    JLabel lNbImages = new JLabel("Combien d'images affichées ?", JLabel.CENTER);
    lNbImages.setFont(_police);
    lNbImages.setOpaque(true);
    lNbImages.setBackground(Color.lightGray);
    lNbImages.setAlignmentX(Component.CENTER_ALIGNMENT);
    JPanel pNbImages = new JPanel(new FlowLayout(FlowLayout.CENTER));
    pNbImages.setOpaque(false);
    pNbImages.add(lNbImages);
    pNbImages.add(_cbNbImages);

    DefaultComboBoxModel mQI = new DefaultComboBoxModel();
    mQI.addElement(TbiCetidem._V_QI_Peu);
    mQI.addElement(TbiCetidem._V_QI_Moyen);
    mQI.addElement(TbiCetidem._V_QI_Beaucoup);
    _cbQuantiteIdentique = new JComboBox(mQI);
    _cbQuantiteIdentique.setSelectedItem(((TbiCetidem)_app).getQuantiteIdentique());
    _cbQuantiteIdentique.setPreferredSize(new Dimension(160,40));
    _cbQuantiteIdentique.setFont(_police);
    JLabel lQuantiteIdentique = new JLabel("Quantité d'images identiques : ", JLabel.CENTER);
    lQuantiteIdentique.setFont(_police);
    lQuantiteIdentique.setOpaque(true);
    lQuantiteIdentique.setBackground(Color.lightGray);
    lQuantiteIdentique.setAlignmentX(Component.CENTER_ALIGNMENT);
    JPanel pQuantiteIdentique = new JPanel(new FlowLayout(FlowLayout.CENTER));
    pQuantiteIdentique.setOpaque(false);
    pQuantiteIdentique.add(lQuantiteIdentique);
    pQuantiteIdentique.add(_cbQuantiteIdentique);
    
    DefaultComboBoxModel mVM = new DefaultComboBoxModel();
    mVM.addElement(TbiCetidem._V_VM_Oui);
    mVM.addElement(TbiCetidem._V_VM_Aleatoire);
    mVM.addElement(TbiCetidem._V_VM_Non);
    _cbVisibiliteModele = new JComboBox(mVM);
    _cbVisibiliteModele.setSelectedItem(((TbiCetidem)_app).getVisibiliteModele());
    _cbVisibiliteModele.setPreferredSize(new Dimension(160,40));
    _cbVisibiliteModele.setFont(_police);
    JLabel lVisibiliteModele = new JLabel("Visibilité du modèle : ", JLabel.CENTER);
    lVisibiliteModele.setFont(_police);
    lVisibiliteModele.setOpaque(true);
    lVisibiliteModele.setBackground(Color.lightGray);
    lVisibiliteModele.setAlignmentX(Component.CENTER_ALIGNMENT);
    JPanel pVisibiliteModele = new JPanel(new FlowLayout(FlowLayout.CENTER));
    pVisibiliteModele.setOpaque(false);
    pVisibiliteModele.add(lVisibiliteModele);
    pVisibiliteModele.add(_cbVisibiliteModele);

    _cbNomPrononce = new JCheckBox("Images avec le nom prononcé ?");
		_cbNomPrononce.setFont(_police);
		_cbNomPrononce.setOpaque(false);
		_cbNomPrononce.setSelected(((TbiCetidem)_app).getAvecNomPrononce());
    JPanel pNomPrononce = new JPanel(new FlowLayout(FlowLayout.CENTER));
    pNomPrononce.setOpaque(false);
    pNomPrononce.add(_cbNomPrononce);
    pNomPrononce.setAlignmentX(CENTER_ALIGNMENT);

    _cbRotation = new JCheckBox("Rotation des images autorisée ?");
		_cbRotation.setFont(_police);
		_cbRotation.setOpaque(false);
		_cbRotation.setSelected(((TbiCetidem)_app).getAvecRotation());
    JPanel pRotation = new JPanel(new FlowLayout(FlowLayout.CENTER));
    pRotation.setOpaque(false);
    pRotation.add(_cbRotation);
    pRotation.setAlignmentX(CENTER_ALIGNMENT);
    
    _tfCheminDesThemes = new JTextField("");
    _tfCheminDesThemes.setPreferredSize(new Dimension(400,30));
    _tfCheminDesThemes.setFont(_police);
    try {
      _bChoisir = new bouton(app.getRessourceByConf("boutonchoisir"));
      _bChoisir.addActionListener(this);
    } catch (Exception e) {
      _app.log(e);
    }
    JLabel lCheminDesThemes = new JLabel("Chemin des thèmes", JLabel.CENTER);
    lCheminDesThemes.setFont(_police);
    lCheminDesThemes.setOpaque(true);
    lCheminDesThemes.setBackground(Color.lightGray);
    JPanel pCheminDesThemes = new JPanel(new FlowLayout(FlowLayout.CENTER));
    pCheminDesThemes.setOpaque(false);
    pCheminDesThemes.add(lCheminDesThemes);    
    pCheminDesThemes.add(_tfCheminDesThemes);
    pCheminDesThemes.add(_bChoisir);
    pCheminDesThemes.setAlignmentX(Component.CENTER_ALIGNMENT);
    
    _pConfExtends.setLayout(new BoxLayout(_pConfExtends, BoxLayout.PAGE_AXIS));
    _pConfExtends.add(pVisibiliteModele);
    _pConfExtends.add(Box.createRigidArea(new Dimension(0,10)));
    _pConfExtends.add(pNbImages);
    _pConfExtends.add(Box.createRigidArea(new Dimension(0,10)));
    _pConfExtends.add(pQuantiteIdentique);
    _pConfExtends.add(Box.createRigidArea(new Dimension(0,10)));
    _pConfExtends.add(pNomPrononce);
    _pConfExtends.add(Box.createRigidArea(new Dimension(0,10)));    
    _pConfExtends.add(pRotation);
    _pConfExtends.add(Box.createRigidArea(new Dimension(0,10)));    
    _pConfExtends.add(pCheminDesThemes);
    _pConfExtends.add(Box.createRigidArea(new Dimension(0,10)));    
  }
  
  protected void preEnregistrer() { // met à jour les config
    super.preEnregistrer();
    ((TbiCetidem)_app).setVisibiliteModele((String)_cbVisibiliteModele.getSelectedItem());
	  ((TbiCetidem)_app).setNbImagesProposees(Integer.parseInt((String)_cbNbImages.getSelectedItem()));
	  ((TbiCetidem)_app).setQuantiteIdentique((String)_cbQuantiteIdentique.getSelectedItem());
	  ((TbiCetidem)_app).setAvecNomPrononce(_cbNomPrononce.isSelected());
	  ((TbiCetidem)_app).setAvecRotation(_cbRotation.isSelected());
		((TbiCetidem)_app).setCheminDesThemes(_tfCheminDesThemes.getText());
  }
  
  public void actionPerformed(ActionEvent evt) {
    super.actionPerformed(evt);
		Object source = evt.getSource();
		if (source == _bChoisir) {
		  JFileChooser chooser = new JFileChooser(_tfCheminDesThemes.getText());
		  chooser.setAcceptAllFileFilterUsed(false);
		  chooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
		  int ret = chooser.showDialog(_app, "Choisir le répertoire contenant les thèmes");
		  if (ret == JFileChooser.APPROVE_OPTION) {
        File file = chooser.getSelectedFile();
  			_tfCheminDesThemes.setText(file.getAbsolutePath());
      }
      chooser.setSelectedFile(null);      
		}
  }
  
  public void init(boolean defaut) {
    super.init(defaut);
    _bSuivant.setEnabled(true);
    _cbVisibiliteModele.setSelectedItem(defaut ? _app.getConfiguration(((TbiCetidem)_app)._V_VisibiliteModele) : ((TbiCetidem)_app).getVisibiliteModele());    
    _cbNbImages.setSelectedItem(defaut ? _app.getConfiguration(((TbiCetidem)_app)._V_NbImagesProposees) : Integer.toString(((TbiCetidem)_app).getNbImagesProposees()));
    _cbQuantiteIdentique.setSelectedItem(defaut ? _app.getConfiguration(((TbiCetidem)_app)._V_QuantiteIdentique) : ((TbiCetidem)_app).getQuantiteIdentique());    
    _cbNomPrononce.setSelected(defaut ? _app.getConfiguration(((TbiCetidem)_app)._V_NomPrononce).toLowerCase().equals("oui") : ((TbiCetidem)_app).getAvecNomPrononce());
    _cbRotation.setSelected(defaut ? _app.getConfiguration(((TbiCetidem)_app)._V_Rotation).toLowerCase().equals("oui") : ((TbiCetidem)_app).getAvecRotation());          
    _tfCheminDesThemes.setText(defaut ? _app.getConfiguration(((TbiCetidem)_app)._V_CheminDesThemes) : ((TbiCetidem)_app).getCheminDesThemes());
  }
  
}
