/*
Copyright Caroline et Serge COUDÉ, (03/2012) 

serge.coude@gmail.com caroline.coude@laposte.net

Ce logiciel est un programme informatique faisant partie d'une suite de 
logiciels 'TbiSuite' à destination des enseignants et des élèves usagés des 
ordinateurs et Tableau Numérique Interactif / Tableau Blanc Interactif. 

Ce logiciel est régi par la licence CeCILL v2 soumise au droit français et
respectant les principes de diffusion des logiciels libres. Vous pouvez
utiliser, modifier et/ou redistribuer ce programme sous les conditions
de la licence CeCILL v2 telle que diffusée par le CEA, le CNRS et l'INRIA 
sur le site "http://www.cecill.info".

En contrepartie de l'accessibilité au code source et des droits de copie,
de modification et de redistribution accordés par cette licence, il n'est
offert aux utilisateurs qu'une garantie limitée.  Pour les mêmes raisons,
seule une responsabilité restreinte pèse sur l'auteur du programme,  le
titulaire des droits patrimoniaux et les concédants successifs.

A cet égard  l'attention de l'utilisateur est attirée sur les risques
associés au chargement,  à l'utilisation,  à la modification et/ou au
développement et à la reproduction du logiciel par l'utilisateur étant 
donné sa spécificité de logiciel libre, qui peut le rendre complexe à 
manipuler et qui le réserve donc à des développeurs et des professionnels
avertis possédant  des  connaissances  informatiques approfondies.  Les
utilisateurs sont donc invités à charger  et  tester  l'adéquation  du
logiciel à leurs besoins dans des conditions permettant d'assurer la
sécurité de leurs systèmes et ou de leurs données et, plus généralement, 
à l'utiliser et l'exploiter dans les mêmes conditions de sécurité. 

Le fait que vous puissiez accéder à cet en-tête signifie que vous avez 
pris connaissance de la licence CeCILL v2, et que vous en avez accepté les
termes.

*/
package net.sergecoude.TbiGeneral;

import net.sergecoude.util.JPanelTranslucide;
import java.awt.event.*;
import javax.swing.*;
import java.awt.*;

public class ItemObjet extends JPanelTranslucide implements IObjetAvecItem, ItemListener {

  private final static long serialVersionUID = 1L;
  
  protected boolean _estSelectionne = false;
  protected ActionListener _actionListener = null;
  protected JList _jListe = null;
  protected CheckBox _cbSelectionne = null;
  protected JLabel _lIntitule = null;
  protected Color _couleurPresentDansEvaluation = new Color(200,200,255);
  protected boolean _presentDansEvaluation = false;

  public ItemObjet(float transparence) {
    super(transparence);
    addComponentListener(this);
    _cbSelectionne = new CheckBox();
    _cbSelectionne.setOpaque(false);
    _cbSelectionne.addItemListener(this);
    _lIntitule = new JLabel();
    setLayout(new FlowLayout(FlowLayout.LEFT));
    add(_cbSelectionne);
    add(_lIntitule);
  }

  public void addItemListener(ItemListener listener) {
    _cbSelectionne.addItemListener(listener);
  }
  
  public JPanel getItem() {
    return this;
  }  
  
  public void setPresentDansEvaluation(boolean present) {
    _presentDansEvaluation = present;
    setSelected(present);
    repaint();
  }
  
  public boolean estPresentDansEvaluation() {
    return _presentDansEvaluation;
  }

  public void paintComponent(Graphics g) {
    super.paintComponent(g);
    g.setColor(_estSelectionne ? _jListe.getSelectionBackground() : (_presentDansEvaluation ? _couleurPresentDansEvaluation : _jListe.getBackground()));
    g.fillRect(0, 0, getWidth(), getHeight());
  }
  
  public void setEnabled(boolean enabled) {
  }
  
  public void setJList(JList l) {
    _jListe = l;
  }
  
  public void setIntitule(String intitule) {
    _lIntitule.setText(intitule);
  }
  
  public void selectionne(boolean select) {
    _estSelectionne = select;
    repaint();
  }
  
  public void setSelected(boolean selected) {
    _cbSelectionne.setSelected(selected);
  }
  
  public boolean isSelected() {
    return _cbSelectionne.isSelected();
  }
  
  public void setHauteur(int h) {
  }
  
  public void itemStateChanged(ItemEvent evt) {
    if (evt.getStateChange() == ItemEvent.SELECTED)
      setSelected(true);
    else
      setSelected(false);
  }
}