/*
Copyright Caroline et Serge COUDÉ, (02/2012) 

serge.coude@gmail.com caroline.coude@laposte.net

Ce logiciel est un programme informatique faisant partie d'une suite de 
logiciels 'TbiSuite' à destination des enseignants et des élèves usagés des 
ordinateurs et Tableau Numérique Interactif / Tableau Blanc Interactif. 

Ce logiciel est régi par la licence CeCILL v2 soumise au droit français et
respectant les principes de diffusion des logiciels libres. Vous pouvez
utiliser, modifier et/ou redistribuer ce programme sous les conditions
de la licence CeCILL v2 telle que diffusée par le CEA, le CNRS et l'INRIA 
sur le site "http://www.cecill.info".

En contrepartie de l'accessibilité au code source et des droits de copie,
de modification et de redistribution accordés par cette licence, il n'est
offert aux utilisateurs qu'une garantie limitée.  Pour les mêmes raisons,
seule une responsabilité restreinte pèse sur l'auteur du programme,  le
titulaire des droits patrimoniaux et les concédants successifs.

A cet égard  l'attention de l'utilisateur est attirée sur les risques
associés au chargement,  à l'utilisation,  à la modification et/ou au
développement et à la reproduction du logiciel par l'utilisateur étant 
donné sa spécificité de logiciel libre, qui peut le rendre complexe à 
manipuler et qui le réserve donc à des développeurs et des professionnels
avertis possédant  des  connaissances  informatiques approfondies.  Les
utilisateurs sont donc invités à charger  et  tester  l'adéquation  du
logiciel à leurs besoins dans des conditions permettant d'assurer la
sécurité de leurs systèmes et ou de leurs données et, plus généralement, 
à l'utiliser et l'exploiter dans les mêmes conditions de sécurité. 

Le fait que vous puissiez accéder à cet en-tête signifie que vous avez 
pris connaissance de la licence CeCILL v2, et que vous en avez accepté les
termes.

*/

package net.sergecoude.TbiGeneral;

import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import java.io.*;

public class PanelTitre extends Panneau {

  private final static long serialVersionUID = 1L;

  protected Font _policeTitre = new Font("SansSerif", Font.BOLD, 60);
  protected Font _policeVersion = new Font("SansSerif", Font.BOLD, 30);
  protected Font _policeLicence = new Font("SansSerif", Font.BOLD, 15);
  protected JPanel _listeLicences;
  protected JScrollPane _listeScroller;
  protected JTextArea _licences = new JTextArea("");
  protected bouton _logoApp;
	
  public PanelTitre(TbiApp app, ApplicationInfo appInf) {
    super(app);
    try {
      _logoApp = new bouton(_app.getRessource("/" + appInf.getNom() + ".png"));
      _logoApp.addActionListener(this);
      _logoApp.setAlignmentX(CENTER_ALIGNMENT);
    } catch(Exception e) {
      _app.log(e);
    }
    
    Box pMain = Box.createVerticalBox();
    pMain.setOpaque(false);
    setLayout(new BorderLayout());
    JLabel labelTitre = new JLabel(appInf.getNom());
    labelTitre.setFont(_policeTitre);
    labelTitre.setAlignmentX(CENTER_ALIGNMENT);
    JLabel labelVersion = new JLabel("                                         " + appInf.getVersion());
    labelVersion.setFont(_policeVersion);
    labelVersion.setAlignmentX(CENTER_ALIGNMENT);
        
    _licences.setFont(_policeLicence);
    _licences.setBackground(Color.lightGray);
    _licences.setLineWrap(true);
    _licences.setWrapStyleWord(true);
    _licences.setText(appInf.getNom() + " est un logiciel de la suite de logiciels 'TbiSuite', créé par Caroline et Serge COUDÉ (" + appInf.getMoisDemarrage() + " - " + appInf.getMoisConception() +") et développé sous licence CeCILL v2 (http://www.cecill.info/licences/Licence_CeCILL_V2-fr.html)\n*** Retrouvez l'ensemble de nos logiciels sur notre site : http://caroline-et-serge.coude.net/ ***");     
    _licences.setText(_licences.getText() + "\n\n" + appInf.getNom() + " utilise la bibliothèque NanoXML 2.2.1 (http://nanoxml.sourceforge.net/orig/index.html) développée par Marc De Scheemaecker sous licence \"zlib/libpng\" (http://www.opensource.org/licenses/zlib-license.html).");
    _licences.setText(_licences.getText() + "\n\n" + appInf.getNom() + " utilise la bibliothèque JOrbis 0.0.17 (http://www.jcraft.com/jorbis/) développée par JCraft sous licence \"LGPL\" (http://www.gnu.org/copyleft/library.html).");         

		_listeScroller = new JScrollPane(_licences, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
    _listeScroller.setOpaque(false);
    _listeScroller.setMinimumSize(new Dimension(850, 200));
    _listeScroller.setPreferredSize(new Dimension(850, 200));
    _listeScroller.setMaximumSize(new Dimension(850, 200));
    pMain.add(labelTitre);
    pMain.add(labelVersion);
    pMain.add(Box.createVerticalStrut(10));
    pMain.add(_logoApp);
    pMain.add(Box.createVerticalStrut(10));
    pMain.add(_listeScroller);
    pMain.add(Box.createVerticalStrut(10));
    add(pMain, BorderLayout.CENTER);
    //pMain.setBorder(BorderFactory.createEmptyBorder(20,30,20,30));
    setBorder(BorderFactory.createEmptyBorder(20,30,20,30));
  }
  
  public void actionPerformed(ActionEvent evt) {
    _app.stopTimer();
    _app.setPanneau("SelectEcran");
  }
  
}
