/*
Copyright Caroline et Serge COUDÉ, (06/2012) 

serge.coude@gmail.com caroline.coude@laposte.net

Ce logiciel est un programme informatique faisant partie d'une suite de 
logiciels 'TbiSuite' à destination des enseignants et des élèves usagés des 
ordinateurs et Tableau Numérique Interactif / Tableau Blanc Interactif. 

Ce logiciel est régi par la licence CeCILL v2 soumise au droit français et
respectant les principes de diffusion des logiciels libres. Vous pouvez
utiliser, modifier et/ou redistribuer ce programme sous les conditions
de la licence CeCILL v2 telle que diffusée par le CEA, le CNRS et l'INRIA 
sur le site "http://www.cecill.info".

En contrepartie de l'accessibilité au code source et des droits de copie,
de modification et de redistribution accordés par cette licence, il n'est
offert aux utilisateurs qu'une garantie limitée.  Pour les mêmes raisons,
seule une responsabilité restreinte pèse sur l'auteur du programme,  le
titulaire des droits patrimoniaux et les concédants successifs.

A cet égard  l'attention de l'utilisateur est attirée sur les risques
associés au chargement,  à l'utilisation,  à la modification et/ou au
développement et à la reproduction du logiciel par l'utilisateur étant 
donné sa spécificité de logiciel libre, qui peut le rendre complexe à 
manipuler et qui le réserve donc à des développeurs et des professionnels
avertis possédant  des  connaissances  informatiques approfondies.  Les
utilisateurs sont donc invités à charger  et  tester  l'adéquation  du
logiciel à leurs besoins dans des conditions permettant d'assurer la
sécurité de leurs systèmes et ou de leurs données et, plus généralement, 
à l'utiliser et l'exploiter dans les mêmes conditions de sécurité. 

Le fait que vous puissiez accéder à cet en-tête signifie que vous avez 
pris connaissance de la licence CeCILL v2, et que vous en avez accepté les
termes.

*/
package net.sergecoude.TbiQuizzSonore;

import java.awt.*;
import javax.swing.*;
import java.io.*;
import java.util.*;
import java.net.*;
import java.awt.image.*;
                        
public class Configuration  {

  private final static long serialVersionUID = 1L;
  
	private String _elementMaitre;
	private Vector<String> _lesElementsRataches;
	private int _type;

	public static int CONFIGURATION_TYPE_INDIFFERENT_ID = 0;
	public static int CONFIGURATION_TYPE_EQUIVALENCE_ID = 1;
	public static String CONFIGURATION_TYPE_EQUIVALENCE_CHAR = "==";
	public static int CONFIGURATION_TYPE_NON_ACCORD_ID = 2;
	public static String CONFIGURATION_TYPE_NON_ACCORD_CHAR = "-=";
			
	public Configuration(String conf) throws Exception {
	  if (conf.indexOf(CONFIGURATION_TYPE_EQUIVALENCE_CHAR) >= 0) {
	   _type = CONFIGURATION_TYPE_EQUIVALENCE_ID;
	   analyse(CONFIGURATION_TYPE_EQUIVALENCE_CHAR, conf); 
	  }
	  if (conf.indexOf(CONFIGURATION_TYPE_NON_ACCORD_CHAR) >= 0) {
	   _type = CONFIGURATION_TYPE_NON_ACCORD_ID;
	   analyse(CONFIGURATION_TYPE_NON_ACCORD_CHAR, conf);
	  }
	}
	
	private void analyse(String sep, String conf) throws Exception {
	  StringTokenizer st = new StringTokenizer(conf, sep);
	  if (st.countTokens() != 2)
      throw new Exception("Mauvaise configuration : " + conf);  
	  _elementMaitre = st.nextToken().trim();
	  StringTokenizer lesElements = new StringTokenizer(st.nextToken().trim(), " ");
	  if (lesElements == null || lesElements.countTokens() == 0)
      throw new Exception("Mauvaise configuration : " + conf);
    _lesElementsRataches = new Vector<String>();
	  while (lesElements.hasMoreTokens()) 
	     _lesElementsRataches.add(lesElements.nextToken());
  }
  
  public int acceptable(String element1, String element2) {
    if (element1.equals(_elementMaitre)) {
      if (_lesElementsRataches.contains(element2)) 
        return _type;
    } else if (element2.equals(_elementMaitre)) {
      if (_lesElementsRataches.contains(element1)) 
        return _type;
    } else if (_lesElementsRataches.contains(element1) && _lesElementsRataches.contains(element2))
      return _type;
    return CONFIGURATION_TYPE_INDIFFERENT_ID;
	}
}