/*
Copyright Caroline et Serge COUDÉ, (06/2012) 

serge.coude@gmail.com caroline.coude@laposte.net

Ce logiciel est un programme informatique faisant partie d'une suite de 
logiciels 'TbiSuite' à destination des enseignants et des élèves usagés des 
ordinateurs et Tableau Numérique Interactif / Tableau Blanc Interactif. 

Ce logiciel est régi par la licence CeCILL v2 soumise au droit français et
respectant les principes de diffusion des logiciels libres. Vous pouvez
utiliser, modifier et/ou redistribuer ce programme sous les conditions
de la licence CeCILL v2 telle que diffusée par le CEA, le CNRS et l'INRIA 
sur le site "http://www.cecill.info".

En contrepartie de l'accessibilité au code source et des droits de copie,
de modification et de redistribution accordés par cette licence, il n'est
offert aux utilisateurs qu'une garantie limitée.  Pour les mêmes raisons,
seule une responsabilité restreinte pèse sur l'auteur du programme,  le
titulaire des droits patrimoniaux et les concédants successifs.

A cet égard  l'attention de l'utilisateur est attirée sur les risques
associés au chargement,  à l'utilisation,  à la modification et/ou au
développement et à la reproduction du logiciel par l'utilisateur étant 
donné sa spécificité de logiciel libre, qui peut le rendre complexe à 
manipuler et qui le réserve donc à des développeurs et des professionnels
avertis possédant  des  connaissances  informatiques approfondies.  Les
utilisateurs sont donc invités à charger  et  tester  l'adéquation  du
logiciel à leurs besoins dans des conditions permettant d'assurer la
sécurité de leurs systèmes et ou de leurs données et, plus généralement, 
à l'utiliser et l'exploiter dans les mêmes conditions de sécurité. 

Le fait que vous puissiez accéder à cet en-tête signifie que vous avez 
pris connaissance de la licence CeCILL v2, et que vous en avez accepté les
termes.

*/

package net.sergecoude.pluginCetidem;

import javax.swing.*;
import java.net.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.util.Map.*;
import javax.swing.event.*;
import java.awt.image.*;
import java.text.*;
import net.sergecoude.TbiGeneral.*;
import net.sergecoude.TbiCetidem.*;
import net.sergecoude.TbiAdmin.*;
import com.itextpdf.text.*;
import com.itextpdf.text.pdf.*;
import org.jfree.chart.*;
import org.jfree.chart.plot.*;
import org.jfree.chart.renderer.category.*;
import org.jfree.data.*;
import org.jfree.data.category.*;
import org.jfree.chart.labels.*;

public class pluginEvaluations extends PluginEvaluations {

  private DefaultListModel _lesThemes = null;
  private Vector<ItemTheme> _lesThemesSelectionnes = new Vector<ItemTheme>();
  private JListJButton _listeThemes = null;
  private JScrollPane _scThemes = null;
  private JCheckBox _cbThemes = null;
  private HashMap<ItemTheme,HashMap<ItemNiveauDifficulte,Vector<ItemEvaluation>>> _lesItems = null;
  private int maxDureeToleree = 60; // 1 minute pour répondre...
  
  @Override
  public String getNomApplication() {
    return "TbiCetidem";
  }

  @Override
  public String getVersionApplication() {
    return "1.0";
  }
  
  public pluginEvaluations() {
    super();
    _nomApplication = getNomApplication() + " " + getVersionApplication();
    try {
    _listeThemes = new JListJButton();
    _listeThemes.setFont(_police);
    _listeThemes.addListSelectionListener(this);
    _listeThemes.addMouseListener(new JListMouseListener(_listeThemes));
    _listeThemes.addMouseListener(this);    
    _listeThemes.setCellRenderer(new ThemeCellRenderer());
    _scThemes = new JScrollPane(_listeThemes);

    _cbThemes = new JCheckBox("Tous");
    _cbThemes.setOpaque(false);
    _cbThemes.setFont(_policeLibelle);
    _cbThemes.addItemListener(this);
    
    setLayout(new BorderLayout(30,0));
    JPanel pMain = new JPanel(new GridLayout(1,3,30,30));
    pMain.setOpaque(false);
    Box pThemes = Box.createVerticalBox();
    Box pThemesHaut = Box.createHorizontalBox();
    JLabel lThemes = new JLabel("Thèmes...", JLabel.LEFT);
    lThemes.setFont(_policeLibelle);
    pThemesHaut.add(Box.createHorizontalGlue());
    pThemesHaut.add(lThemes);
    pThemesHaut.add(Box.createHorizontalGlue());
    pThemesHaut.add(_cbThemes);
    pThemesHaut.setAlignmentX(Component.CENTER_ALIGNMENT);
    pThemes.add(pThemesHaut);
    _scThemes.setAlignmentX(Component.CENTER_ALIGNMENT);
    pThemes.add(_scThemes);
    pMain.add(pThemes);
    Box pNiveaux = Box.createVerticalBox();
    Box pNiveauxHaut = Box.createHorizontalBox();
    JLabel lNiveaux = new JLabel("Niveaux de difficulté...", JLabel.LEFT);
    lNiveaux.setFont(_policeLibelle);
    pNiveauxHaut.add(Box.createHorizontalGlue());
    pNiveauxHaut.add(lNiveaux);
    pNiveauxHaut.add(Box.createHorizontalGlue());
    pNiveauxHaut.add(_cbNiveaux);
    pNiveauxHaut.setAlignmentX(Component.CENTER_ALIGNMENT);
    pNiveaux.add(pNiveauxHaut);
    _scNiveaux.setAlignmentX(Component.CENTER_ALIGNMENT);
    pNiveaux.add(_scNiveaux);
    pMain.add(pNiveaux);
    Box pEvaluations = Box.createVerticalBox();
    Box pEvaluationsHaut = Box.createHorizontalBox();
    JLabel lEvaluations = new JLabel("Evaluations...", JLabel.LEFT);
    lEvaluations.setFont(_policeLibelle);
    pEvaluationsHaut.add(Box.createHorizontalGlue());
    pEvaluationsHaut.add(lEvaluations);
    pEvaluationsHaut.add(Box.createHorizontalGlue());
    pEvaluationsHaut.add(_cbEvaluations);
    pEvaluationsHaut.setAlignmentX(Component.CENTER_ALIGNMENT);
    pEvaluations.add(pEvaluationsHaut);
    _scEvaluations.setAlignmentX(Component.CENTER_ALIGNMENT);
    pEvaluations.add(_scEvaluations);
    pMain.add(pEvaluations);
    add(pMain, BorderLayout.CENTER);
    } catch(Exception e) {
      e.printStackTrace();
    }
    _lesItems = new HashMap<ItemTheme,HashMap<ItemNiveauDifficulte,Vector<ItemEvaluation>>>();       
  }
  
  @Override
  public void init(TbiApp app, Application application) {
    super.init(app, application);
    _app = (TbiAdmin)app;
    chargeLesThemes(); // initialise la hashmap _lesItems puis charge les évaluations  
    creePanneauTypesGraphiques();
  }
  
  @Override
  public void reset() {
    super.reset();
    _listeThemes.clearSelection();
    _listeNiveaux.setModel(new DefaultListModel());
    _listeEvaluations.setModel(new DefaultListModel());
    majPlugin();  }

  @Override   
  protected JComponent creePanneauTypesGraphiques() {
    JComponent pTypesGraphiques = super.creePanneauTypesGraphiques();
    add(pTypesGraphiques, BorderLayout.EAST);
    _bMires.setVisible(false);
    _cbMires.setVisible(false);
    _cbMires.setSelected(false);
    _cbReponses.setSelected(true);
    return pTypesGraphiques;
  }
  
  private ItemNiveauDifficulte creeItemNiveauDifficulte(String visibiliteModele, boolean rotationPossible, int nbImages, String quantiteIdentiques, int rang) {
    String libelle = "";
    if (visibiliteModele.equals("oui"))
      libelle = "visible";
    if (visibiliteModele.equals("non"))
      libelle = "caché";
    if (visibiliteModele.equals("aleatoire"))
      libelle = "aléatoire";
    libelle += ", " + nbImages + ", " + quantiteIdentiques + ", ";
    if (rotationPossible)
      libelle += "rotation";
    else
      libelle += "pas de rotation";
    String code = visibiliteModele + "-" + nbImages + "-" + quantiteIdentiques + "-" + (rotationPossible ? "1" : "0");
    ItemNiveauDifficulte item = new ItemNiveauDifficulte(new NiveauDifficulte(libelle, code, rang));
    item.addItemListener(this);
    return item;    
  }
  
  @Override
  protected Vector<ItemNiveauDifficulte> creeLesItemsNiveauxDifficulte() {
    Vector<ItemNiveauDifficulte> lesItemsNiveauxDifficulte = super.creeLesItemsNiveauxDifficulte();
    String[] lesVisibilites = { "non", "aleatoire", "oui" };
    String[] lesQuantitesIdentiques = { "peu", "moyen", "beaucoup" };
    int cpt = 0;
    for(int i = 0; i < lesVisibilites.length; i++) {
      for(int j = 0; j < 2; j++) {
        for(int k = 6; k >= 2; k--) {
          for(int l = 0; l < lesQuantitesIdentiques.length; l++) {
            lesItemsNiveauxDifficulte.addElement(creeItemNiveauDifficulte(lesVisibilites[i], (j == 0), k, lesQuantitesIdentiques[l], cpt));
            cpt++;
          }
        }
      }
    } 
    return lesItemsNiveauxDifficulte;
  }
  
  private String getCheminDesThemes() {
    File fichierConf = new File("TbiCetidem/TbiCetidem.conf");
    if (fichierConf.exists()) {
      try {
        FileInputStream isConf = new FileInputStream(fichierConf);      				  
        BufferedReader readerConf = new BufferedReader(new InputStreamReader(isConf));
        String ligne;
        while ((ligne = readerConf.readLine()) != null) {
          ligne = ligne.trim();
          if (ligne.toLowerCase().startsWith("<chemindesthemes>")) {
            ligne = ligne.substring("<chemindesthemes>".length());
            ligne = ligne.substring(0,ligne.indexOf("<"));
            readerConf.close();
            return ligne;
          }
        }
        readerConf.close();
      } catch(Exception e) {
      } 
    }
    return ".";
  }
  
  private void chargeLesThemes() {
    _app.message("Chargement des thèmes...", _app.MESSAGE_INFORMATION, 0);
    if (_lesThemes == null) {
      _lesThemes = new DefaultListModel();
      _listeThemes.setModel(_lesThemes);
    }
    _lesThemes.clear();
    _listeThemes.setEnabled(false);
    _listeNiveaux.setEnabled(false);
    File[] fichiers = null;
    File rep = new File(getCheminDesThemes());
    fichiers = rep.listFiles();
    if (fichiers != null) {
      for(int f = 0; f < fichiers.length; f++) {
        if (fichiers[f].isDirectory()) {
          File desc = new File(fichiers[f], "description.txt");
          File icon = new File(fichiers[f], "icon.jpg");
          if (desc.exists() && icon.exists()) {
            try {
              Theme theme = new Theme(fichiers[f]);
              ItemTheme item = new ItemTheme(theme);
              item.addItemListener(this);
              _lesThemes.addElement(item);
              HashMap<ItemNiveauDifficulte,Vector<ItemEvaluation>> lesItemsNiveauxDifficulte = new HashMap<ItemNiveauDifficulte,Vector<ItemEvaluation>>();
              Vector<ItemNiveauDifficulte> vItemsNiveauxDifficulte = creeLesItemsNiveauxDifficulte();
              for(int i = 0; i < vItemsNiveauxDifficulte.size(); i++) 
                lesItemsNiveauxDifficulte.put(vItemsNiveauxDifficulte.elementAt(i), new Vector<ItemEvaluation>());
              _lesItems.put(item, lesItemsNiveauxDifficulte);
            } catch (Exception e) {
                _app.message(e, _app.MESSAGE_AVERTISSEMENT);      
            }
          }
        }
      }
    }
    _listeThemes.setEnabled(true);
    _listeNiveaux.setEnabled(true);
    if (_lesThemes.getSize() > 0)
      _app.message("Chargement des thèmes : " + _lesThemes.getSize() + " trouvé" + (_lesThemes.getSize() > 1 ? "s" : "") + " !", _app.MESSAGE_INFORMATION, 3000);
    else 
      _app.message("Chargement des thèmes : aucun thème trouvé...", _app.MESSAGE_AVERTISSEMENT, 3000);
    chargeLesEvaluations();  
  }
  
  private Vector<ItemEvaluation> getItemsEvaluationsDuThemeEtDuNiveau(String nTheme, String cNiveau) {
    HashMap<ItemNiveauDifficulte,Vector<ItemEvaluation>> lesNiveaux = getItemsNiveauxDifficulteDuTheme(nTheme);
    if (lesNiveaux != null)
      for(Entry<ItemNiveauDifficulte,Vector<ItemEvaluation>> entreeNiveau : lesNiveaux.entrySet()) {
        ItemNiveauDifficulte itemNiveau = entreeNiveau.getKey();
        NiveauDifficulte niveau = itemNiveau.getNiveauDifficulte();
        if (niveau.getCode().equals(cNiveau))
          return entreeNiveau.getValue();
      }     
    return null;
  } 
  
  private HashMap<ItemNiveauDifficulte,Vector<ItemEvaluation>> getItemsNiveauxDifficulteDuTheme(String nTheme) {
    for(Entry<ItemTheme, HashMap<ItemNiveauDifficulte,Vector<ItemEvaluation>>> entreeItem : _lesItems.entrySet()) {
      ItemTheme itemTheme = entreeItem.getKey();
      Theme theme = (Theme)itemTheme.getTheme();
      if (theme.getNom().equals(nTheme)) {
        return entreeItem.getValue();
      }  
    }
    return null;
  }
  
  private ItemTheme getItemThemeDuNiveauDifficulte(ItemNiveauDifficulte itemNiveau) {
    for(Entry<ItemTheme, HashMap<ItemNiveauDifficulte,Vector<ItemEvaluation>>> entreeItem : _lesItems.entrySet()) {
      ItemTheme itemTheme = entreeItem.getKey();
      HashMap<ItemNiveauDifficulte,Vector<ItemEvaluation>> lesNiveaux = entreeItem.getValue();
      if (lesNiveaux != null)
        for(Entry<ItemNiveauDifficulte,Vector<ItemEvaluation>> entreeNiveau : lesNiveaux.entrySet()) {
          ItemNiveauDifficulte iNiveau = entreeNiveau.getKey();
          if (iNiveau == itemNiveau)
            return itemTheme;
        }
    }
    return null;
  }
  
  private ItemNiveauDifficulte getItemNiveauDifficulteDeEvaluation(ItemEvaluation itemEvaluation) {
    for(Entry<ItemTheme, HashMap<ItemNiveauDifficulte,Vector<ItemEvaluation>>> entreeItem : _lesItems.entrySet()) {
      ItemTheme itemTheme = entreeItem.getKey();
      HashMap<ItemNiveauDifficulte,Vector<ItemEvaluation>> lesNiveaux = entreeItem.getValue();
      if (lesNiveaux != null)
        for(Entry<ItemNiveauDifficulte,Vector<ItemEvaluation>> entreeNiveau : lesNiveaux.entrySet()) {
          ItemNiveauDifficulte iNiveau = entreeNiveau.getKey();
          Vector<ItemEvaluation> lesEvaluations = entreeNiveau.getValue();
          if (lesEvaluations != null) {
            for(int e = 0; e < lesEvaluations.size(); e++) 
              if (lesEvaluations.elementAt(e) == itemEvaluation)
                return iNiveau;
          }
        }      
    }
    return null;
  }
  
  private Vector<ItemEvaluation> getItemsEvaluationsDuNiveau(ItemNiveauDifficulte itemNiveau) {
    for(Entry<ItemTheme, HashMap<ItemNiveauDifficulte,Vector<ItemEvaluation>>> entreeItem : _lesItems.entrySet()) {
      ItemTheme itemTheme = entreeItem.getKey();
      HashMap<ItemNiveauDifficulte,Vector<ItemEvaluation>> lesNiveaux = entreeItem.getValue();
      if (lesNiveaux != null)
        for(Entry<ItemNiveauDifficulte,Vector<ItemEvaluation>> entreeNiveau : lesNiveaux.entrySet()) {
          ItemNiveauDifficulte iNiveau = entreeNiveau.getKey();
          if (iNiveau == itemNiveau)
            return entreeNiveau.getValue();
        }
    }
    return null;
  }
  
  @Override
  public void videLesEvaluations() {
    for(Entry<ItemTheme, HashMap<ItemNiveauDifficulte,Vector<ItemEvaluation>>> entreeItem : _lesItems.entrySet()) 
      for(Entry<ItemNiveauDifficulte,Vector<ItemEvaluation>> entreeNiveau : entreeItem.getValue().entrySet()) 
        entreeNiveau.getValue().clear(); // les itemsEvaluations
  }
  
  @Override
  public void chargeLesEvaluations() {
    // appelée par init ou par reset
    // charge la totalité des évaluations de TbiCetidem pour la classe sélectionée et les réparti en fonction du theme et du niveau de difficulté
    _app.message("Chargement des évaluations pour le plugin " + getNomApplication() + "...", _app.MESSAGE_INFORMATION, 3000);
    videLesEvaluations();    
    File repertoire = new File(((TbiAdmin)_app).getCheminDesEvaluations() + File.separator + _application.getRepertoire().getName());
    int cptErreur = 0;
    int cptEval = 0;
    if (repertoire.exists()) {
      File[] fichiers = repertoire.listFiles();
      if (fichiers != null) {
        for(int f = 0; f < fichiers.length; f++) {
          if (fichiers[f].isFile() && fichiers[f].getName().endsWith("-eval.xml")) {
            try {
              EvaluationCetidem eval = new EvaluationCetidem(_app, fichiers[f].getAbsolutePath());
              String nTheme  = eval.getNom();
              String cNiveau = eval.getCodeNiveauDifficulte();
              if (eval.getClasse().getId().equals(_laClasseSelectionnee.getId())) {
                Vector<ItemEvaluation> lesItemsEvaluationsDuThemeEtDuNiveau = getItemsEvaluationsDuThemeEtDuNiveau(nTheme, cNiveau);
                if (lesItemsEvaluationsDuThemeEtDuNiveau == null)
                  throw new Exception("Impossible de trouver le thème '" + nTheme + "' et le niveau '" + cNiveau + "' pour l'évaluation " + fichiers[f].getName() + "...");
                ItemEvaluation itemEval = new ItemEvaluation(eval);
                itemEval.addItemListener(this);
                lesItemsEvaluationsDuThemeEtDuNiveau.addElement(itemEval);
                cptEval++;
              }
            } catch(Exception e) {
              _app.message(e.toString(), _app.MESSAGE_AVERTISSEMENT, 3000);
              cptErreur++;
            }
          }
        }
      }
    }
    // tri des évaluations de la plus récente à la plus ancienne pour chaque thème et chaque niveau
    // coche les items "thème", "niveau" et "évaluation" si présents dans les évaluations
    ArrayList<ParametreDeTri> lesParametres = new ArrayList<ParametreDeTri>();
    lesParametres.add(new ParametreDeTri(Evaluation.DATE_DESC, "Date récente->ancienne"));
    for(Entry<ItemTheme, HashMap<ItemNiveauDifficulte,Vector<ItemEvaluation>>> entreeItem : _lesItems.entrySet()) {
      ItemTheme itemTheme = entreeItem.getKey();
      HashMap<ItemNiveauDifficulte,Vector<ItemEvaluation>> lesNiveaux = entreeItem.getValue();
      boolean themePresent = false;
      for(Entry<ItemNiveauDifficulte,Vector<ItemEvaluation>> entreeNiveau : lesNiveaux.entrySet()) {
        ItemNiveauDifficulte itemNiveau = entreeNiveau.getKey();
        Vector<ItemEvaluation> lesItemsEvaluations = entreeNiveau.getValue();
        boolean niveauPresent = false;
        if (lesItemsEvaluations.size() > 0) {
          for(int e = 0; e < lesItemsEvaluations.size(); e++) 
            lesItemsEvaluations.elementAt(e).setPresentDansEvaluation(true);
          niveauPresent = true;
          themePresent = true;
        }
        itemNiveau.setPresentDansEvaluation(niveauPresent);
      }
      itemTheme.setPresentDansEvaluation(themePresent);
    }
    if (cptEval > 0) {
      _app.message("Chargement des évaluations du plugin " + getNomApplication() + " et la classe " + _laClasseSelectionnee.getNom() + " : " + cptEval + " trouvée" + (cptEval > 1 ? "s" : "") + " !" + (cptErreur > 0 ? " (+ " + cptErreur + " erronnée" + (cptErreur > 1 ? "s" : "") + ")" : ""), (cptErreur > 0 ? _app.MESSAGE_AVERTISSEMENT : _app.MESSAGE_INFORMATION), 3000);
    } else 
      _app.message("Chargement des évaluations du plugin " + getNomApplication() + " et la classe " + _laClasseSelectionnee.getNom() + " : aucune évaluation trouvée..." + (cptErreur > 0 ? " (+ " + cptErreur + " erronnée" + (cptErreur > 1 ? "s" : "") + ")" : ""), (cptErreur > 0 ? _app.MESSAGE_AVERTISSEMENT : _app.MESSAGE_INFORMATION), 3000);
    ((TbiAdmin)_app).majPlugin(this);
  }
  
  @Override
  public void valueChanged(ListSelectionEvent evt) {
    if (!evt.getValueIsAdjusting()) {
      if (evt.getSource() == _listeThemes) {
        ItemTheme iTheme = (ItemTheme)_listeThemes.getSelectedValue();
        if (iTheme != null) {
          HashMap<ItemNiveauDifficulte,Vector<ItemEvaluation>> lesItemsNiveauxDifficulte = getItemsNiveauxDifficulteDuTheme(iTheme.getTheme().getNom());
          if (lesItemsNiveauxDifficulte != null) {
            Vector<ItemNiveauDifficulte> listeNiveaux = new Vector<ItemNiveauDifficulte>();
            for(Entry<ItemNiveauDifficulte,Vector<ItemEvaluation>> entreeNiveau : lesItemsNiveauxDifficulte.entrySet()) 
              listeNiveaux.addElement(entreeNiveau.getKey());
            // tri des niveaux de difficulté du plus facile au plus difficile
            ArrayList<ParametreDeTri> lesParametres = new ArrayList<ParametreDeTri>();
            lesParametres.add(new ParametreDeTri(NiveauDifficulte.RANG_ASC, "facile -> difficile"));
            Comparator<ItemNiveauDifficulte> cp = ItemNiveauDifficulte.getComparator(lesParametres);
            Collections.sort(listeNiveaux, cp);
            _listeNiveaux.setModel(Vector2Model(listeNiveaux));
            _listeEvaluations.setModel(new DefaultListModel());
          }
        }  
      }
      if (evt.getSource() == _listeNiveaux) {
        ItemNiveauDifficulte iNiveau = (ItemNiveauDifficulte)_listeNiveaux.getSelectedValue();
        if (iNiveau != null) {
          Vector<ItemEvaluation> lesItemsEvaluations = getItemsEvaluationsDuThemeEtDuNiveau(((ItemTheme)_listeThemes.getSelectedValue()).getTheme().getNom(), iNiveau.getNiveauDifficulte().getCode());
          if (lesItemsEvaluations != null) {
            // tri des évaluations de la plus récente à la plus ancienne
            ArrayList<ParametreDeTri> lesParametres = new ArrayList<ParametreDeTri>();
            lesParametres.add(new ParametreDeTri(Evaluation.DATE_DESC, "Date récente->ancienne"));
            Comparator<ItemEvaluation> cp = ItemEvaluation.getComparator(lesParametres);
            Collections.sort(lesItemsEvaluations, cp);
            _listeEvaluations.setModel(Vector2Model(lesItemsEvaluations));
          }
        } else {
          _listeEvaluations.setModel(new DefaultListModel());
        }
      }
      ((TbiAdmin)_app).majPlugin(this);
    }
  }

  @Override
  public void setSelected(boolean selected) {
    if (_lesItems != null)
      for(Entry<ItemTheme,HashMap<ItemNiveauDifficulte,Vector<ItemEvaluation>>> entreeTheme : _lesItems.entrySet()) {
        ItemTheme itemTheme = entreeTheme.getKey();
        itemTheme.setSelected(selected && itemTheme.estPresentDansEvaluation());
      }
    majPlugin();
  }  
  
  @Override
  public void itemStateChanged(ItemEvent evt) {
    if (evt.getSource() == _cbThemes) {
      if (_listeThemes.getModel() != null && 
          _listeThemes.getModel().getSize() > 0) {
        selectionneTousLesThemes(_cbThemes.isSelected());
      }
    }
    super.itemStateChanged(evt);
    if (evt.getSource() instanceof CheckBox) {
      CheckBox cb = (CheckBox)evt.getSource();
      if (cb.getParent() instanceof ItemTheme) {
        ItemTheme item = (ItemTheme)cb.getParent();
        HashMap<ItemNiveauDifficulte,Vector<ItemEvaluation>> lesNiveaux = getItemsNiveauxDifficulteDuTheme(item.getTheme().getNom()); 
        if (lesNiveaux != null)
          for(Entry<ItemNiveauDifficulte,Vector<ItemEvaluation>> entreeNiveau : lesNiveaux.entrySet()) {
            ItemNiveauDifficulte itemNiveau = entreeNiveau.getKey();
            if (item.isSelected() && itemNiveau.estPresentDansEvaluation())
              itemNiveau.setSelected(true);
            else 
              itemNiveau.setSelected(false); 
        } 
      }
      if (cb.getParent() instanceof ItemNiveauDifficulte) {
        ItemNiveauDifficulte item = (ItemNiveauDifficulte)cb.getParent();
        Vector<ItemEvaluation> lesItemsEvaluations = getItemsEvaluationsDuNiveau(item);
        if (lesItemsEvaluations != null) 
          for(int e = 0; e < lesItemsEvaluations.size(); e++) {
            ItemEvaluation iEval = lesItemsEvaluations.elementAt(e);
            if (item.isSelected() && iEval.estPresentDansEvaluation())
              iEval.setSelected(true);
            else 
              iEval.setSelected(false); 
          }
      }
      if (cb.getParent() instanceof ItemEvaluation) {
        ItemEvaluation item = (ItemEvaluation)cb.getParent();
        // rien à faire
      }
    }
  }
  
  private Vector<ItemTheme> getItemsThemesSelectionnes() {
    ListModel liste = _listeThemes.getModel();
    Vector<ItemTheme> lesItemsThemes = new Vector<ItemTheme>();
    for(int t = 0; t < liste.getSize(); t++) {
      ItemTheme item = (ItemTheme)liste.getElementAt(t);
      if (item.isSelected())
        lesItemsThemes.addElement(item);  
    }
    return lesItemsThemes;
  }
  
  private void selectionneTousLesThemes(boolean selected) {
    ListModel liste = _listeThemes.getModel();
    for(int t = 0; t < liste.getSize(); t++) {
      ItemTheme item = (ItemTheme)liste.getElementAt(t);
      item.setSelected(selected);
    }
    ((TbiAdmin)_app).majPlugin(this);    
    _scThemes.repaint();
  }
  
  public Vector<ItemEvaluation> getLesItemsEvaluationsSelectionnes(boolean selected) {
    Vector<ItemEvaluation> res = new Vector<ItemEvaluation>();
    for(Entry<ItemTheme, HashMap<ItemNiveauDifficulte,Vector<ItemEvaluation>>> entreeTheme : _lesItems.entrySet()) 
      for(Entry<ItemNiveauDifficulte,Vector<ItemEvaluation>> entreeNiveau : entreeTheme.getValue().entrySet()) {
        Vector<ItemEvaluation> lesItemsEvaluations =  entreeNiveau.getValue();
        for(int i = 0; i < lesItemsEvaluations.size(); i++) {
          ItemEvaluation item = lesItemsEvaluations.elementAt(i);
          if ((selected && item.isSelected()) || !selected)
            res.addElement(item);
        }
      }
    return res;      
  }
  
  @Override
	public boolean generationPDFPossible() {
    return (getItemsThemesSelectionnes().size() > 0);
  }
  
  private PdfPTable genereCartoucheParApplication(Theme theme) {
    PdfPTable cartouche = new PdfPTable(new float[] {1f, 1f});
 		cartouche.setWidthPercentage(60);
 		cartouche.setHorizontalAlignment(com.itextpdf.text.Element.ALIGN_LEFT);
    Paragraph pClasse = new Paragraph("Classe : " + _app.getClasseSelectionnee().getNom(), FontFactory.getFont(FontFactory.HELVETICA, 10, com.itextpdf.text.Font.BOLD));
    pClasse.setAlignment(com.itextpdf.text.Element.ALIGN_LEFT);
 		PdfPCell cClasse = new PdfPCell(pClasse);
    cartouche.addCell(cClasse);
    HashMap<ItemNiveauDifficulte,Vector<ItemEvaluation>> lesItemsNiveauxDifficulte =  getItemsNiveauxDifficulteDuTheme(theme.getNom());
    String niveauxPresents = "";
    for(Entry<ItemNiveauDifficulte,Vector<ItemEvaluation>> entreeNiveau : lesItemsNiveauxDifficulte.entrySet()) {
      ItemNiveauDifficulte itemNiveau = entreeNiveau.getKey();
      NiveauDifficulte niveau = itemNiveau.getNiveauDifficulte();
      if (itemNiveau.isSelected())  
        niveauxPresents += niveau.getIntitule() + "\n";
    }
    Paragraph pNiveaux = new Paragraph(niveauxPresents, FontFactory.getFont(FontFactory.HELVETICA, 10));          
    PdfPCell cNiveaux = new PdfPCell(pNiveaux);
    cNiveaux.setRowspan(3);
    cartouche.addCell(cNiveaux);
    Paragraph pTitre = new Paragraph(_nomApplication, FontFactory.getFont(FontFactory.HELVETICA, 12));
    pTitre.setAlignment(com.itextpdf.text.Element.ALIGN_CENTER);
  	PdfPCell cTitre = new PdfPCell(pTitre);
    cartouche.addCell(cTitre);
    Paragraph pTheme = new Paragraph(theme.getNom(), FontFactory.getFont(FontFactory.HELVETICA, 10));
    PdfPCell cTheme = new PdfPCell(pTheme);
  	cTheme.setBackgroundColor(_couleurFondTitre);
    cartouche.addCell(cTheme);
    cartouche.setSpacingBefore(10f);                  
    return cartouche;
  }
  
  private PdfPTable genereTableauMiresTousEleves(Theme theme, Vector<EvaluationCetidem> lesEvaluationsCetidem) throws DocumentException, IOException {
    float[] colsWidth = {2.5f, 1f, 1f, 1f, 1f, 1f, 1f, 1f, 1f, 1f, 1f};
  	PdfPTable tableau = new PdfPTable(colsWidth);
  	/*tableau.setWidthPercentage(100);
  	tableau.setHorizontalAlignment(com.itextpdf.text.Element.ALIGN_LEFT);
  	tableau.setHeaderRows(1);
  	tableau.setSpacingBefore(15f);
    // titre    
    PdfPCell cell = new PdfPCell(new Paragraph("Elève \\ Date"));
    cell.setBackgroundColor(_couleurFondTitre); 
    tableau.addCell(cell);
    com.itextpdf.text.Font policeDateEval = new com.itextpdf.text.Font(com.itextpdf.text.Font.FontFamily.HELVETICA, 8, com.itextpdf.text.Font.BOLD);
    PdfPCell defaultCell = tableau.getDefaultCell();
    BaseColor couleurFondCelluleOriginale = defaultCell.getBackgroundColor();
    defaultCell.setBackgroundColor(_couleurFondTitre);
    String derDateEval = "";
    int derRangEval = 1;
    for(int e = 0; e < lesEvaluationsCetidem.size(); e++) {
 	    EvaluationCetidem eval = lesEvaluationsCetidem.elementAt(e);
 	    if (eval.getNom().equals(theme.getNom())) {
 	      String dateEval = formateDate(eval.getDateStart());
        if (dateEval.equals(derDateEval))
          derRangEval++;
        else {
          derDateEval = dateEval;
          derRangEval = 1; 
        }
        String sEvalNum = dateEval + (derRangEval > 1 ? "-"+derRangEval : ""); 
        Phrase pEvalNum = new Phrase(sEvalNum, policeDateEval);
        cell = new PdfPCell(pEvalNum);
        cell.setHorizontalAlignment(com.itextpdf.text.Element.ALIGN_CENTER);
        cell.setBackgroundColor(_couleurFondTitre); 
        tableau.addCell(cell);
      }
    }
    tableau.completeRow();
    // calcul de la hauteur d'une ligne
   	float hauteurLigne = 700f / (_lesElevesSelectionnes.size()+1);
   	if (hauteurLigne > 50f)
   	  hauteurLigne = 50f;
   	if (hauteurLigne < 20f)
   	  hauteurLigne = 20f;
  	// les élèves
    defaultCell = tableau.getDefaultCell();
    defaultCell.setBackgroundColor(couleurFondCelluleOriginale);      	    
  	defaultCell.setFixedHeight(hauteurLigne);
  	for(int e = 0; e < _lesElevesSelectionnes.size(); e++) {
      Eleve eleve = _lesElevesSelectionnes.elementAt(e);
      Phrase pEleve = new Phrase(eleve.getNomUsuel());
      PdfPCell cEleve = new PdfPCell(pEleve);
      cEleve.setFixedHeight(hauteurLigne);
      tableau.addCell(cEleve);
      for(int v = 0; v < lesEvaluationsCetidem.size(); v++) {
        EvaluationCetidem eval = lesEvaluationsCetidem.elementAt(v);
        if (eval.getNom().equals(theme.getNom())) {
          if (eval.elevePresent(eleve)) {
            Mire mire = genereMire(eval, eleve);
            if (mire != null) {
              com.itextpdf.text.Image imgMire = com.itextpdf.text.Image.getInstance((java.awt.Image)mire.getBufferedImage(150,150) , null);
              PdfPCell mireCell = new PdfPCell(imgMire, true);
              mireCell.setFixedHeight(hauteurLigne);
              mireCell.setPadding(hauteurLigne*0.05f);
              mireCell.setHorizontalAlignment(com.itextpdf.text.Element.ALIGN_CENTER);
              tableau.addCell(mireCell);
            }
          } else {
              PdfPCell videCell = new PdfPCell();
              videCell.setFixedHeight(hauteurLigne);
              tableau.addCell(videCell);
          }
        }
      }
      tableau.completeRow();
    }*/
    return tableau;
  }
  
  private PdfPTable genereTableauTempsTousEleves(Theme theme, Vector<EvaluationCetidem> lesEvaluationsCetidem) throws DocumentException, IOException {
  	PdfPTable tableau = new PdfPTable(new float[] {1f});
  	tableau.setWidthPercentage(100);
  	tableau.setHorizontalAlignment(com.itextpdf.text.Element.ALIGN_LEFT);
  	tableau.setSpacingBefore(15f);
   	for(int e = 0; e < _lesElevesSelectionnes.size(); e++) {
      Eleve eleve = _lesElevesSelectionnes.elementAt(e);
      Phrase pEleve = new Phrase(eleve.getNomUsuel());
      PdfPCell cEleve = new PdfPCell(pEleve);
      tableau.addCell(cEleve);
      DefaultCategoryDataset dataset = new DefaultCategoryDataset();
      String derDateEval = "";
      int derRangEval = 1;
      for(int v = 0; v < lesEvaluationsCetidem.size(); v++) {
        EvaluationCetidem eval = lesEvaluationsCetidem.elementAt(v);
        if (eval.getNom().equals(theme.getNom()) && eval.elevePresent(eleve)) {
   	      String dateEval = formateDate(eval.getDateStart());
          if (dateEval.equals(derDateEval))
            derRangEval++;
          else {
            derDateEval = dateEval;
            derRangEval = 1; 
          }
          genereDataset(eval, eleve, dataset, (derRangEval > 1 ? derRangEval : 0));
        }
      }
      CategoryDataset categoryDataset = dataset;
      JFreeChart chart = ChartFactory.createLineChart
        ("",
         "",
         "secondes",
         categoryDataset,
         PlotOrientation.VERTICAL,
         false,
         false,
         false);
      CategoryPlot plot = (CategoryPlot)chart.getPlot();    
      plot.setBackgroundPaint(Color.white);
      plot.setNoDataMessage("pas d'évaluation...");
      int dureeMax = (getDureeReponse(true)/1000);
      if (dureeMax > maxDureeToleree)
        dureeMax = maxDureeToleree;  
      plot.getRangeAxis().setRange(0, dureeMax*1.2);
      LineAndShapeRenderer serieRenderer = (LineAndShapeRenderer)plot.getRenderer();
      serieRenderer.setSeriesItemLabelGenerator(0, new StandardCategoryItemLabelGenerator("{2}", new DecimalFormat("0")));
      serieRenderer.setSeriesPaint(0, Color.black);
      serieRenderer.setSeriesItemLabelsVisible(0, true); 
      PdfPCell cChart = new PdfPCell(com.itextpdf.text.Image.getInstance((java.awt.Image)chart.createBufferedImage(800,150) , null), true);
      tableau.addCell(cChart);
    }
    return tableau;
  }   

  private String genereListeReponses(Eleve eleve, EvaluationCetidem eval, int rang) {
    String liste = "";
    String dateEvaluation = formateDate(eval.getDateStart()) + (rang == 0 ? "" : "-"+rang);
    Vector<Epreuve> lesEpreuves = eval.getLesEpreuves();
    for(int a = 0; a < lesEpreuves.size(); a++) {
      EpreuveCetidem ep = (EpreuveCetidem)lesEpreuves.elementAt(a);
      if (ep.getEleve().getId().equals(eleve.getId())) {
        Vector<Exercice> lesExercices = ep.getLesExercices();
        for(int b = 0; b < lesExercices.size(); b++) {
          ExerciceCetidem ex = (ExerciceCetidem)lesExercices.elementAt(b);
          net.sergecoude.TbiCetidem.Element bonneReponse = ex.getBonneReponse();
          liste += dateEvaluation + "[" + ex.getRang() + "] - ";
          liste += bonneReponse + "(" + (ex.getVisibiliteModele() ? "visible" : "caché") + ")" + " -";
          int nbEchec = ex.getNbEnregistrementsEchec();
          Vector<Enregistrement> lesEnregistrements = ex.getLesEnregistrements();
          if (nbEchec == 0)
            liste += " (0 faute !)";
          else 
            liste += " (" + nbEchec + " faute" + (nbEchec > 1 ? "s" : "") + ") : "; 
          // tri les réponses par ordre chronologique (le rang de 1 à ...)
          ArrayList<ParametreDeTri> lesParametres = new ArrayList<ParametreDeTri>();
          lesParametres.add(new ParametreDeTri(Enregistrement.RANG_ASC, "Rang croissant"));
          Comparator<Enregistrement> cp = Enregistrement.getComparator(lesParametres);
          Collections.sort(lesEnregistrements, cp);
          nbEchec = 0;          
          for(int c = 0; c < lesEnregistrements.size(); c++) {
            EnregistrementCetidem enr = (EnregistrementCetidem)lesEnregistrements.elementAt(c);
            if (!enr.estUnSucces()) {
              if (nbEchec > 0)
                liste += ",";
              nbEchec++;
              net.sergecoude.TbiCetidem.Element reponse = enr.getChoix();
              String rep = reponse.toString();
              if (rep.endsWith("90"))
                rep = rep.substring(0,rep.length()-2) + "[pivoté à 90°]";
              if (rep.endsWith("180"))
                rep = rep.substring(0,rep.length()-3) + "[pivoté à 180°]";
              if (rep.endsWith("270"))
                rep = rep.substring(0,rep.length()-3) + "[pivoté à 270°]";
              liste += rep;
            }  
          }
          liste += "\n";
        }
      }
    }
    return liste;
  }

  private PdfPTable genereTableauReponsesTousEleves(Theme theme, Vector<EvaluationCetidem> lesEvaluationsCetidem) throws DocumentException, IOException {
    PdfPTable tableau = new PdfPTable(new float[] {1f});
  	tableau.setWidthPercentage(100);
  	tableau.setHorizontalAlignment(com.itextpdf.text.Element.ALIGN_LEFT);
  	tableau.setSpacingBefore(15f);
   	for(int e = 0; e < _lesElevesSelectionnes.size(); e++) {
      Eleve eleve = _lesElevesSelectionnes.elementAt(e);
      Phrase pEleve = new Phrase(eleve.getNomUsuel());
      PdfPCell cEleve = new PdfPCell(pEleve);
      tableau.addCell(cEleve);
      String lesReponsesDeEleve = "";
      String derDateEval = "";
      int derRangEval = 1;
      for(int v = 0; v < lesEvaluationsCetidem.size(); v++) {
        EvaluationCetidem eval = lesEvaluationsCetidem.elementAt(v);
        if (eval.getNom().equals(theme.getNom()) && eval.elevePresent(eleve)) {
   	      String dateEval = formateDate(eval.getDateStart());
          if (dateEval.equals(derDateEval))
            derRangEval++;
          else {
            derDateEval = dateEval;
            derRangEval = 1; 
          }
          lesReponsesDeEleve += genereListeReponses(eleve, eval, (derRangEval > 1 ? derRangEval : 0)) + "\n";
        }
      }
      PdfPCell cReponses = new PdfPCell(new Paragraph(lesReponsesDeEleve, _policePDFReponses));
      tableau.addCell(cReponses);
    }
    return tableau;
  }   

  @Override
  public ObjetPDF genererPDF(ObjetPDF oPDF) throws DocumentException, FileNotFoundException, IOException  {
    oPDF = super.genererPDF(oPDF);
    Vector<ItemTheme> lesThemesSelectionnes = getItemsThemesSelectionnes();
    for(int t = 0; t < lesThemesSelectionnes.size(); t++) {
		  oPDF.document.add(genereCartoucheParApplication(lesThemesSelectionnes.elementAt(t).getTheme()));
	    // definition des évaluations sélectionnées
      Vector<EvaluationCetidem> lesEvaluationsCetidem = new Vector<EvaluationCetidem>();
      for(Entry<ItemNiveauDifficulte,Vector<ItemEvaluation>> entreeNiveau : getItemsNiveauxDifficulteDuTheme(lesThemesSelectionnes.elementAt(t).getTheme().getNom()).entrySet()) {    
        Vector<ItemEvaluation> lesItemsEvaluations = getItemsEvaluationsDuNiveau(entreeNiveau.getKey());
 	      for(int i = 0; i < lesItemsEvaluations.size(); i++) {
 	        ItemEvaluation item = lesItemsEvaluations.elementAt(i);
 	        if (item.isSelected())
 	          lesEvaluationsCetidem.addElement((EvaluationCetidem)item.getEvaluation());
 	      }
      }
      // tri des évaluations de la plus ancienne à la plus récente
      ArrayList<ParametreDeTri> lesParametres = new ArrayList<ParametreDeTri>();
      lesParametres.add(new ParametreDeTri(Evaluation.DATE_ASC, "Date ancienne->récente"));
      Comparator<Evaluation> cp = Evaluation.getComparator(lesParametres);
      Collections.sort(lesEvaluationsCetidem, cp);
      // genere les graphiques suivant les choix de l'utilisateur
  		if (_cbMires.isSelected())
        oPDF.document.add(genereTableauMiresTousEleves(lesThemesSelectionnes.elementAt(t).getTheme(), lesEvaluationsCetidem));
  		if (_cbTemps.isSelected()) {
  		  if (_cbMires.isSelected())
          oPDF.document.newPage();
        oPDF.document.add(genereTableauTempsTousEleves(lesThemesSelectionnes.elementAt(t).getTheme(), lesEvaluationsCetidem));   
      }
  		if (_cbReponses.isSelected()) {
  		  if (_cbMires.isSelected() || _cbTemps.isSelected())
          oPDF.document.newPage();
        oPDF.document.add(genereTableauReponsesTousEleves(lesThemesSelectionnes.elementAt(t).getTheme(), lesEvaluationsCetidem));   
      }
      if (t < lesThemesSelectionnes.size()-1) {
        oPDF.document.newPage();
      }
    }
    return oPDF;        
  }
  
  private PdfPTable genereCartoucheParEleve(Theme theme) {
  	// cartouche Application
  	BaseColor coulFondTitre = new BaseColor(230,230,230);
    PdfPTable cartouche = new PdfPTable(new float[] {1f, 1f});
 	  cartouche.setWidthPercentage(60);
 	  cartouche.setHorizontalAlignment(com.itextpdf.text.Element.ALIGN_LEFT);
    Paragraph pTitre = new Paragraph(_nomApplication, FontFactory.getFont(FontFactory.HELVETICA, 12));
    pTitre.setAlignment(com.itextpdf.text.Element.ALIGN_CENTER);
  	PdfPCell cTitre = new PdfPCell(pTitre);
    cartouche.addCell(cTitre);
    HashMap<ItemNiveauDifficulte,Vector<ItemEvaluation>> lesItemsNiveauxDifficulte =  getItemsNiveauxDifficulteDuTheme(theme.getNom());
    String niveauxPresents = "";
    for(Entry<ItemNiveauDifficulte,Vector<ItemEvaluation>> entreeNiveau : lesItemsNiveauxDifficulte.entrySet()) {
      ItemNiveauDifficulte itemNiveau = entreeNiveau.getKey();
      NiveauDifficulte niveau = itemNiveau.getNiveauDifficulte();
      if (itemNiveau.isSelected())  
        niveauxPresents += niveau.getIntitule() + "\n";
    }
    Paragraph pNiveaux = new Paragraph(niveauxPresents, FontFactory.getFont(FontFactory.HELVETICA, 10));          
    PdfPCell cNiveaux = new PdfPCell(pNiveaux);
    cNiveaux.setRowspan(2);
    cartouche.addCell(cNiveaux);
    Paragraph pTheme = new Paragraph(theme.getNom(), FontFactory.getFont(FontFactory.HELVETICA, 10));
    PdfPCell cTheme = new PdfPCell(pTheme);
		cTheme.setBackgroundColor(coulFondTitre);
    cartouche.addCell(cTheme);
    cartouche.setSpacingBefore(10f);                  
    return cartouche;
  }  
  
  public PdfPTable genereTableauMiresUnEleve(Theme theme, Vector<EvaluationCetidem> lesEvaluationsCetidem, Eleve eleve) throws DocumentException, IOException {
 	  float hauteurLigne = 30f;
	  float[] colsWidth = {1f, 1f, 1f, 1f, 1f, 1f, 1f, 1f, 1f, 1f, 1f};
	  PdfPTable tableau = new PdfPTable(colsWidth);
	 /* tableau.setWidthPercentage(100);
 	  tableau.setHorizontalAlignment(com.itextpdf.text.Element.ALIGN_LEFT);
 	  tableau.setHeaderRows(1);
    PdfPCell defaultCell = tableau.getDefaultCell();
    defaultCell.setFixedHeight(hauteurLigne/2);
    com.itextpdf.text.Font policeDateEval = new com.itextpdf.text.Font(com.itextpdf.text.Font.FontFamily.HELVETICA, 8, com.itextpdf.text.Font.BOLD);
    int nbColonnesUtilisees = 0; 
    String derDateEval = "";
    int derRangEval = 1;
    for(int e = 0; e < lesEvaluationsCetidem.size(); e++) {
 	    EvaluationCetidem eval = lesEvaluationsCetidem.elementAt(e);
 	    if (eval.getNom().equals(theme.getNom())) {
 	      String dateEval = formateDate(eval.getDateStart());
        if (dateEval.equals(derDateEval))
          derRangEval++;
        else {
          derDateEval = dateEval;
          derRangEval = 1; 
        }
        String sEvalNum = dateEval + (derRangEval > 1 ? "-"+derRangEval : ""); 
        Phrase pEvalNum = new Phrase(sEvalNum, policeDateEval);
        PdfPCell cell = new PdfPCell(pEvalNum);
        cell.setHorizontalAlignment(com.itextpdf.text.Element.ALIGN_CENTER);
        tableau.addCell(cell);
        nbColonnesUtilisees++;
      }
    }
    tableau.completeRow();
    defaultCell = tableau.getDefaultCell();
    defaultCell.setFixedHeight(hauteurLigne);
   	for(int v = 0; v < lesEvaluationsCetidem.size(); v++) {
      EvaluationCetidem eval = lesEvaluationsCetidem.elementAt(v);
   		if (eval.getNom().equals(theme.getNom())) {
        if (eval.elevePresent(eleve)) {
          Mire mire = genereMire(eval, eleve);
          if (mire != null) {
            com.itextpdf.text.Image imgMire = com.itextpdf.text.Image.getInstance((java.awt.Image)mire.getBufferedImage(150,150) , null);
            PdfPCell mireCell = new PdfPCell(imgMire, true);
            mireCell.setFixedHeight(hauteurLigne);
            mireCell.setPadding(hauteurLigne*0.05f);
            mireCell.setHorizontalAlignment(com.itextpdf.text.Element.ALIGN_CENTER);
            tableau.addCell(mireCell);
          } 
        } else {
            PdfPCell videCell = new PdfPCell();
            videCell.setFixedHeight(hauteurLigne);
            tableau.addCell(videCell);
        } 
      }
    }
    tableau.completeRow(); */
    return tableau;
  }
  
  private PdfPTable genereTableauTempsUnEleve(Theme theme, Vector<EvaluationCetidem> lesEvaluationsCetidem, Eleve eleve) throws DocumentException, IOException {
  	PdfPTable tableau = new PdfPTable(new float[] {1f});
  	tableau.setWidthPercentage(100);
  	tableau.setHorizontalAlignment(com.itextpdf.text.Element.ALIGN_LEFT);
  	tableau.setSpacingBefore(15f);
    Phrase pEleve = new Phrase(eleve.getNomUsuel());
    PdfPCell cEleve = new PdfPCell(pEleve);
    tableau.addCell(cEleve);
    DefaultCategoryDataset dataset = new DefaultCategoryDataset();
    String derDateEval = "";
    int derRangEval = 1;
    for(int v = 0; v < lesEvaluationsCetidem.size(); v++) {
      EvaluationCetidem eval = lesEvaluationsCetidem.elementAt(v);
      if (eval.getNom().equals(theme.getNom()) && eval.elevePresent(eleve)) { 
 	      String dateEval = formateDate(eval.getDateStart());
        if (dateEval.equals(derDateEval))
          derRangEval++;
        else {
          derDateEval = dateEval;
          derRangEval = 1; 
        }
        genereDataset(eval, eleve, dataset, (derRangEval > 1 ? derRangEval : 0));
      }
    }
    CategoryDataset categoryDataset = dataset;
    JFreeChart chart = ChartFactory.createLineChart
      ("",
       "",
       "secondes",
       categoryDataset,
       PlotOrientation.VERTICAL,
       false,
       false,
       false);
    CategoryPlot plot = (CategoryPlot)chart.getPlot();    
    plot.setBackgroundPaint(Color.white);
    plot.setNoDataMessage("pas d'évaluation...");
    int dureeMax = (getDureeReponse(true)/1000)+1;
    if (dureeMax > maxDureeToleree)
      dureeMax = maxDureeToleree;  
    plot.getRangeAxis().setRange(0, dureeMax*1.2);
    LineAndShapeRenderer serieRenderer = (LineAndShapeRenderer)plot.getRenderer();
//    CategoryItemLabelGenerator generator = new StandardCategoryItemLabelGenerator("{2}", new DecimalFormat("0"));
    serieRenderer.setSeriesItemLabelGenerator(0, new StandardCategoryItemLabelGenerator("{2}", new DecimalFormat("0")));
    serieRenderer.setSeriesPaint(0, Color.black);
    serieRenderer.setSeriesItemLabelsVisible(0, true); 
    PdfPCell cChart = new PdfPCell(com.itextpdf.text.Image.getInstance((java.awt.Image)chart.createBufferedImage(800,150) , null), true);
    tableau.addCell(cChart);
    return tableau;
  }
   
  private PdfPTable genereTableauReponsesUnEleve(Theme theme, Vector<EvaluationCetidem> lesEvaluationsCetidem, Eleve eleve) throws DocumentException, IOException {
  	PdfPTable tableau = new PdfPTable(new float[] {1f});
  	tableau.setWidthPercentage(100);
  	tableau.setHorizontalAlignment(com.itextpdf.text.Element.ALIGN_LEFT);
  	tableau.setSpacingBefore(15f);
    PdfPTable lesReponsesDeEleve = new PdfPTable(new float[] {1f});
    String derDateEval = "";
    int derRangEval = 1;                
    Paragraph pInformations = new Paragraph("(Liste des réponses erronées si erreurs commises)", FontFactory.getFont(FontFactory.HELVETICA, 8, com.itextpdf.text.Font.BOLD+com.itextpdf.text.Font.ITALIC));
    PdfPCell cInformations = new PdfPCell(pInformations);
    tableau.addCell(cInformations);
    for(int v = 0; v < lesEvaluationsCetidem.size(); v++) {
      EvaluationCetidem eval = lesEvaluationsCetidem.elementAt(v);
      if (eval.getNom().equals(theme.getNom()) && eval.elevePresent(eleve)) {
 	      String dateEval = formateDate(eval.getDateStart());
        if (dateEval.equals(derDateEval))
          derRangEval++;
        else {
          derDateEval = dateEval;
          derRangEval = 1; 
        }
        Paragraph pReponses = new Paragraph(genereListeReponses(eleve, eval, (derRangEval > 1 ? derRangEval : 0)), _policePDFReponses);
        lesReponsesDeEleve.addCell(pReponses);
      }
    }
    PdfPCell cReponses = new PdfPCell(lesReponsesDeEleve);
    tableau.addCell(cReponses);
    return tableau;
  }      
  
  @Override
  public ObjetPDF genererPDF(ObjetPDF oPDF, Eleve eleve) throws DocumentException, FileNotFoundException, IOException  {
    oPDF = super.genererPDF(oPDF, eleve);
    BaseColor coulFondTitre = new BaseColor(230,230,230);    
    // definition des évaluations sélectionnées (tous les thèmes)
    Vector<ItemEvaluation> lesItemsEvaluations = getLesItemsEvaluationsSelectionnes(true);
    Vector<EvaluationCetidem> lesEvaluationsCetidem = new Vector<EvaluationCetidem>();
    for(int i = 0; i < lesItemsEvaluations.size(); i++) {
      ItemEvaluation item = lesItemsEvaluations.elementAt(i);
      lesEvaluationsCetidem.addElement((EvaluationCetidem)item.getEvaluation());
    }
    // tri des évaluations de la plus ancienne à la plus récente
    ArrayList<ParametreDeTri> lesParametres = new ArrayList<ParametreDeTri>();
    lesParametres.add(new ParametreDeTri(Evaluation.DATE_ASC, "Date ancienne->récente"));
    Comparator<Evaluation> cp = Evaluation.getComparator(lesParametres);
    Collections.sort(lesEvaluationsCetidem, cp);
    Vector<ItemTheme> lesThemesSelectionnes = getItemsThemesSelectionnes();
    for(int t = 0; t < lesThemesSelectionnes.size(); t++) {
      oPDF.document.add(genereCartoucheParEleve(lesThemesSelectionnes.elementAt(t).getTheme()));
      // genere les graphiques suivant les choix de l'utilisateur
  		if (_cbMires.isSelected())
        oPDF.document.add(genereTableauMiresUnEleve(lesThemesSelectionnes.elementAt(t).getTheme(), lesEvaluationsCetidem, eleve));
  		if (_cbTemps.isSelected()) {
        oPDF.document.add(genereTableauTempsUnEleve(lesThemesSelectionnes.elementAt(t).getTheme(), lesEvaluationsCetidem, eleve));   
      }
  		if (_cbReponses.isSelected()) {
        oPDF.document.add(genereTableauReponsesUnEleve(lesThemesSelectionnes.elementAt(t).getTheme(), lesEvaluationsCetidem, eleve));   
      }      
    }
    return oPDF;        
  }
  
  @Override
  public Mire genereMire(Evaluation evaluation, Eleve eleve) {
    EvaluationCetidem ev = (EvaluationCetidem)evaluation;
    Vector<Epreuve> lesEpreuves = ev.getLesEpreuves();
    for(int j = 0; j < lesEpreuves.size(); j++) {
      Epreuve ep = lesEpreuves.elementAt(j);
      if (ep.getEleve().getId().equals(eleve.getId())) {
        Mire mire = new Mire();
        mire.setNbExercicesCorrects(ep.getNbSucces());
        mire.setNbExercices(ev.getNbExercices());
        return mire;
      }
    }
    return null;
  }
  
  @Override
  public void majPlugin() {
    super.majPlugin();
    _scThemes.repaint();
    _scNiveaux.repaint();
    _scEvaluations.repaint();
  } 
  
}